import type {Meta, StoryObj} from '@storybook/web-components';
import {html} from 'lit';
import {SearchRoot} from '../search-root/search-root';
import {FacetDropdown} from './facet-dropdown';

//@ts-expect-error required import.
const a = FacetDropdown;
//@ts-expect-error required import.
const b = SearchRoot;

const meta: Meta = {
  title: 'Facets/facet-dropdown',
  tags: ['autodocs'],
  component: 'facet-dropdown',
  decorators: [
    (story) =>
      html`
        <search-root url="/mock/api/search/mock-index" defaultPerPage="10">
          ${story()}
        </search-root>
      `,
  ],
};

export default meta;
type Story = StoryObj;

export const Primary: Story = {
  render: ({
    key,
    overrideLabel,
    showLabel,
    selectLabel,
    showReset,
    resetText,
  }) =>
    html`<facet-dropdown
      key="${key}"
      overrideLabel="${overrideLabel}"
      ?showLabel="${showLabel}"
      selectLabel="${selectLabel}"
      ?showReset="${showReset}"
      ?resetText="${resetText}"
    ></facet-dropdown>`,
  args: {
    key: 'type',
    overrideLabel: '',
    showLabel: true,
    selectLabel: 'Select an option',
    showReset: true,
    resetText: '',
  },
};

export const Collapsible: Story = {
  render: ({
    key,
    overrideLabel,
    showLabel,
    selectLabel,
    showReset,
    resetText,
    collapsible,
    closed,
    showCountInCollapseLabel,
  }) =>
    html`<facet-dropdown
      key="${key}"
      overrideLabel="${overrideLabel}"
      ?showLabel="${showLabel}"
      selectLabel="${selectLabel}"
      ?showReset="${showReset}"
      ?resetText="${resetText}"
      ?collapsible="${collapsible}"
      ?closed="${closed}"
      ?showCountInCollapseLabel="${showCountInCollapseLabel}"
    ></facet-dropdown>`,
  args: {
    key: 'type',
    overrideLabel: '',
    showLabel: true,
    selectLabel: 'Select an option',
    showReset: true,
    resetText: '',
    collapsible: true,
    closed: true,
    showCountInCollapseLabel: true,
  },
};
